<?php

namespace App\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Component\Form\Extension\Core\Type\IntegerType;
use Symfony\Component\Form\FormBuilderInterface;

class OsmoseToolType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('item', IntegerType::class, [
                'label' => 'Item',
                'help_html' => true,
                'help' => 'Voir la liste sur <a href="https://wiki.openstreetmap.org/wiki/FR:Osmose/issues" target="_blank">le wiki</a>',
            ])
            ->add('source', IntegerType::class, [
                'label' => 'Identifiant source',
            ])
            ->add('class', IntegerType::class, [
                'label' => 'Identifiant de la classe',
            ])
            ->add('limit', IntegerType::class, [
                'label' => 'Limite',
                'help' => 'Nombre mmaximal de signalements à renvoyer',
            ])
            ->add('group_by_city', CheckboxType::class, [
                'label' => 'Grouper par commune',
                'required' => false,
            ])
        ;
    }
}
